searchData={"content_type":"text/plain","items":[{"doc":"speed_trap a simple yet effective rate_limiter for Erlang speed_trap uses the token bucket algorithm and implements this algorithm by making use of atomics to represent a bucket. Granularity of buckets is provided by allowing new buckets (see: speed_trap:new/2 ) to be created using any arbitrary speed_trap:id() . An example of such id could be: {&lt;&lt;localhost:8080/path/to/resource&quot;&gt;&gt;, &lt;&lt;&quot;POST&quot;&gt;&gt;} with a generic id being &lt;&lt;&quot;POST&quot;&gt;&gt; Generic buckets can subsequently be setup (see: speed_trap:new/2 ) using a more generic speed_trap:id() such as just &lt;&lt;&quot;username&quot;&gt;&gt; . Each time a request is made, one simpy checks if allowed by using speed_trap:try_pass/1 . In case a bucket needs modification, either increase or decrease the size and interval, one can use the speed_trap:modify/2 in order to adjust the limits.","ref":"speed_trap.html","title":"speed_trap","type":"module"},{"doc":null,"ref":"speed_trap.html#all/0","title":"speed_trap.all/0","type":"function"},{"doc":null,"ref":"speed_trap.html#block/1","title":"speed_trap.block/1","type":"function"},{"doc":"Deletes a token bucket as well as a possibly stored template based token bucket override and hence removes a rate limiter.","ref":"speed_trap.html#delete/1","title":"speed_trap.delete/1","type":"function"},{"doc":"Deletes a token bucket by id. If the second argument is true also deletes a possibly stored template based token bucket override.","ref":"speed_trap.html#delete/2","title":"speed_trap.delete/2","type":"function"},{"doc":"Deletes a template based token bucket override by id.","ref":"speed_trap.html#delete_override/1","title":"speed_trap.delete_override/1","type":"function"},{"doc":"Modify an existing TokenBucket and decrease/increase its size and/or refill interval. Modifying a TokenBucket always fully refills it.","ref":"speed_trap.html#modify/2","title":"speed_trap.modify/2","type":"function"},{"doc":"Setup a new TokenBucket. This is where a rate_limiter is setup for any arbitrary identifier.","ref":"speed_trap.html#new/2","title":"speed_trap.new/2","type":"function"},{"doc":null,"ref":"speed_trap.html#options/1","title":"speed_trap.options/1","type":"function"},{"doc":"Try grabbing a token from a TokenBucket. As long as this function is ok, the request is not rate limited.","ref":"speed_trap.html#try_pass/1","title":"speed_trap.try_pass/1","type":"function"},{"doc":"If any of the ids, do not pass then there's a small chance that we end up with a RefillCount + 1 token if the timer has fired in between the timer calling speed_trap_token_bucket:add_token/4 and us returning the token that we have just grabbed for the speed_traps which we successfully managed to take a token for. This way, you will end up with RefillCount + 1 token","ref":"speed_trap.html#try_pass_all/1","title":"speed_trap.try_pass_all/1","type":"function"},{"doc":null,"ref":"speed_trap.html#unblock/1","title":"speed_trap.unblock/1","type":"function"},{"doc":null,"ref":"speed_trap.html#t:already_exists/0","title":"speed_trap.already_exists/0","type":"type"},{"doc":null,"ref":"speed_trap.html#t:blocked/0","title":"speed_trap.blocked/0","type":"type"},{"doc":null,"ref":"speed_trap.html#t:bucket_size/0","title":"speed_trap.bucket_size/0","type":"type"},{"doc":null,"ref":"speed_trap.html#t:id/0","title":"speed_trap.id/0","type":"type"},{"doc":null,"ref":"speed_trap.html#t:modify_options/0","title":"speed_trap.modify_options/0","type":"type"},{"doc":null,"ref":"speed_trap.html#t:no_such_speed_trap/0","title":"speed_trap.no_such_speed_trap/0","type":"type"},{"doc":null,"ref":"speed_trap.html#t:options/0","title":"speed_trap.options/0","type":"type"},{"doc":null,"ref":"speed_trap.html#t:override/0","title":"speed_trap.override/0","type":"type"},{"doc":null,"ref":"speed_trap.html#t:rate_limit_not_enforced/0","title":"speed_trap.rate_limit_not_enforced/0","type":"type"},{"doc":null,"ref":"speed_trap.html#t:refill_count/0","title":"speed_trap.refill_count/0","type":"type"},{"doc":null,"ref":"speed_trap.html#t:refill_interval/0","title":"speed_trap.refill_interval/0","type":"type"},{"doc":null,"ref":"speed_trap.html#t:stored_options/0","title":"speed_trap.stored_options/0","type":"type"},{"doc":null,"ref":"speed_trap.html#t:too_many_requests/0","title":"speed_trap.too_many_requests/0","type":"type"},{"doc":null,"ref":"speed_trap.html#t:try_pass_all_result/0","title":"speed_trap.try_pass_all_result/0","type":"type"},{"doc":null,"ref":"speed_trap.html#t:try_pass_failure/0","title":"speed_trap.try_pass_failure/0","type":"type"},{"doc":null,"ref":"speed_trap.html#t:try_pass_result/0","title":"speed_trap.try_pass_result/0","type":"type"},{"doc":null,"ref":"speed_trap.html#t:try_pass_success/0","title":"speed_trap.try_pass_success/0","type":"type"},{"doc":"speed_trap_app","ref":"speed_trap_app.html","title":"speed_trap_app","type":"module"},{"doc":"Start the speed_trap application.","ref":"speed_trap_app.html#start/2","title":"speed_trap_app.start/2","type":"function"},{"doc":"Clean up after the speed_trap application has stopped.","ref":"speed_trap_app.html#stop/1","title":"speed_trap_app.stop/1","type":"function"},{"doc":null,"ref":"speed_trap_options.html","title":"speed_trap_options","type":"module"},{"doc":null,"ref":"speed_trap_options.html#validate/2","title":"speed_trap_options.validate/2","type":"function"},{"doc":null,"ref":"speed_trap_options.html#t:bad_options/0","title":"speed_trap_options.bad_options/0","type":"type"},{"doc":"speed_trap top level supervisor.","ref":"speed_trap_sup.html","title":"speed_trap_sup","type":"module"},{"doc":null,"ref":"speed_trap_sup.html#init/1","title":"speed_trap_sup.init/1","type":"function"},{"doc":"Start the top level supervisor.","ref":"speed_trap_sup.html#start_link/0","title":"speed_trap_sup.start_link/0","type":"function"},{"doc":null,"ref":"speed_trap_template.html","title":"speed_trap_template","type":"module"},{"doc":null,"ref":"speed_trap_template.html#cleanup/0","title":"speed_trap_template.cleanup/0","type":"function"},{"doc":null,"ref":"speed_trap_template.html#current_id_patterns/0","title":"speed_trap_template.current_id_patterns/0","type":"function"},{"doc":null,"ref":"speed_trap_template.html#current_templates/0","title":"speed_trap_template.current_templates/0","type":"function"},{"doc":null,"ref":"speed_trap_template.html#init/0","title":"speed_trap_template.init/0","type":"function"},{"doc":null,"ref":"speed_trap_template.html#init/2","title":"speed_trap_template.init/2","type":"function"},{"doc":null,"ref":"speed_trap_template.html#options_from_id/1","title":"speed_trap_template.options_from_id/1","type":"function"},{"doc":null,"ref":"speed_trap_template.html#t:bucket_id_pattern/0","title":"speed_trap_template.bucket_id_pattern/0","type":"type"},{"doc":null,"ref":"speed_trap_template.html#t:id/0","title":"speed_trap_template.id/0","type":"type"},{"doc":null,"ref":"speed_trap_template.html#t:id_pattern/0","title":"speed_trap_template.id_pattern/0","type":"type"},{"doc":null,"ref":"speed_trap_template.html#t:templates/0","title":"speed_trap_template.templates/0","type":"type"},{"doc":"speed_trap_token_bucket implementation with atomics. The current number of tokens is stored as a mutable atomic variable. When a token is taken from the bucket, the counter is decremented. It is allowed for the counter to become negative. Adding tokens to the counter requires multiple operations. Since there is no operation to add with a threshold (contrary to ets:update_counter/3 for example), the value is first read and then incremented if necessary. It is possible that the value will be decremented between the two operations, but it cannot be incremented (given there's only one updater running at a time), so there's no risk of adding tokens above the bucket's capacity. On the other hand, the counter going below 0 is an issue that needs special handling: whenever the update operation finds a negative value, it sets the counter to 1. Incrementing it is not safe in this case, as concurrent processes may try to get tokens from the bucket, pushing its value to even lower between the read and the update. It's worth mentioning that although counters can underflow, it is not a practical risk to call get_token/1 2^63 times in a single refill interval. For simplicity, the actual updates are scheduled via timer:apply_interval/4 , however an interval timer is linked to the process creating it. Therefore we need a simple server to own and manage these timers.","ref":"speed_trap_token_bucket.html","title":"speed_trap_token_bucket","type":"module"},{"doc":null,"ref":"speed_trap_token_bucket.html#active_buckets/0","title":"speed_trap_token_bucket.active_buckets/0","type":"function"},{"doc":null,"ref":"speed_trap_token_bucket.html#add_token/4","title":"speed_trap_token_bucket.add_token/4","type":"function"},{"doc":null,"ref":"speed_trap_token_bucket.html#bucket/1","title":"speed_trap_token_bucket.bucket/1","type":"function"},{"doc":"Deletes a scheduled function by its id. The second parameter indicates whether to try deleting a store template based token bucket override by id or not.","ref":"speed_trap_token_bucket.html#delete/2","title":"speed_trap_token_bucket.delete/2","type":"function"},{"doc":"Deletes a possibly stored token bucket override from the store.","ref":"speed_trap_token_bucket.html#delete_override/1","title":"speed_trap_token_bucket.delete_override/1","type":"function"},{"doc":"Cleans up the overrides store.","ref":"speed_trap_token_bucket.html#delete_overrides/0","title":"speed_trap_token_bucket.delete_overrides/0","type":"function"},{"doc":"Gets an override from the overrides store.","ref":"speed_trap_token_bucket.html#get_override/1","title":"speed_trap_token_bucket.get_override/1","type":"function"},{"doc":null,"ref":"speed_trap_token_bucket.html#get_token/1","title":"speed_trap_token_bucket.get_token/1","type":"function"},{"doc":null,"ref":"speed_trap_token_bucket.html#handle_call/3","title":"speed_trap_token_bucket.handle_call/3","type":"function"},{"doc":null,"ref":"speed_trap_token_bucket.html#handle_cast/2","title":"speed_trap_token_bucket.handle_cast/2","type":"function"},{"doc":null,"ref":"speed_trap_token_bucket.html#handle_info/2","title":"speed_trap_token_bucket.handle_info/2","type":"function"},{"doc":null,"ref":"speed_trap_token_bucket.html#init/1","title":"speed_trap_token_bucket.init/1","type":"function"},{"doc":"Modifies the scheduled function already registered under the given id.","ref":"speed_trap_token_bucket.html#modify/2","title":"speed_trap_token_bucket.modify/2","type":"function"},{"doc":"Add a new function to the scheduler. The provided MFA will be registered under the given id and applied every refill interval milliseconds.","ref":"speed_trap_token_bucket.html#new/2","title":"speed_trap_token_bucket.new/2","type":"function"},{"doc":null,"ref":"speed_trap_token_bucket.html#options/1","title":"speed_trap_token_bucket.options/1","type":"function"},{"doc":null,"ref":"speed_trap_token_bucket.html#return_token/1","title":"speed_trap_token_bucket.return_token/1","type":"function"},{"doc":"Start the scheduler server.","ref":"speed_trap_token_bucket.html#start_link/0","title":"speed_trap_token_bucket.start_link/0","type":"function"},{"doc":null,"ref":"speed_trap_token_bucket.html#t:state/0","title":"speed_trap_token_bucket.state/0","type":"type"},{"doc":null,"ref":"speed_trap_token_bucket.html#t:token_bucket/0","title":"speed_trap_token_bucket.token_bucket/0","type":"type"},{"doc":"# speed_trap\nA basic Token Bucket rate limiter written in Erlang with no external dependencies.\n\n[![Build](https://github.com/klarna/speed_trap/actions/workflows/build.yml/badge.svg)](https://github.com/klarna/speed_trap/actions/workflows/build.yml)\n[![License](https://camo.githubusercontent.com/7b7d3d8a196e3828ccb78dfedc3c626aab728508cbd8e1cfbe27ef9c8216229e/68747470733a2f2f696d672e736869656c64732e696f2f62616467652f6c6963656e73652d417061636865253230322d626c75653f7374796c653d666c61742d737175617265)](http://www.apache.org/licenses/LICENSE-2.0)\n![GitHub last commit](https://img.shields.io/github/last-commit/klarna/speed_trap?style=flat-square)\n[![Developed at Klarna](https://camo.githubusercontent.com/3b04c776d2140980743e386cf674fa4d3ad9dad97a2d514833f47eb77a5bb37e/68747470733a2f2f736869656c64732e696f2f62616467652f446576656c6f70656425323061742532304b6c61726e612d626c61636b3f6c6f676f3d6b6c61726e61)](https://github.com/klarna)","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"A basic [Token Bucket](https://en.wikipedia.org/wiki/Token_bucket) based rate limiter for Erlang.\nThis is a rate limiter in it's most basic form and uses atomics in order to keep track of\nwhether or not a request should be rate limited on a per node basis.\n\nTests were performed across an [atomics](https://www.erlang.org/doc/man/atomics.html),\n[ets](https://www.erlang.org/doc/man/ets.html) and a [gen_server](https://www.erlang.org/doc/man/gen_server.html)\nbased implementation.\n\nAlthough the benchmark is not provided as part of `speed_trap`, the results are as follows:\n\n| Implementation | Throughput     | Standard deviation   |\n|----------------|----------------|----------------------|\n| `atomics`      | 31,000,000 cps |             0.915 ms |\n| `ets`          |    760,000 cps |                11 ms |\n| `gen_server`   |    640,000 cps |             0.517 ms |","ref":"readme.html#features","title":"Features - Overview","type":"extras"},{"doc":"A token bucket rate limiter is defined by four mandatory parameters:\n\n* `bucket_size`, positive integer, represents maximum number of tokens that can be available\n  to a client\n* `refill_interval`, milliseconds, how often the bucket is refilled with tokens\n* `refill_count`, positive integer, how many tokens are added every refill\n* `delete_when_full`, boolean, whether or not to delete the bucket when it's filled up\n\nOptional parameters:\n* `override`, `none | not_enforced | blocked`, whether to override the rate limiter to always allow or block requests. `not_enforced` behaves the same as any other regular rate limiter with the exception that once the bucket is empty, one would receive `{ok, rate_limit_not_enforced}` rather than `{error, too_many_requests}`. This features allows a soft-launch of any rate limiter and allows one to tweak the limits before enforcing the rate limiter. `blocked` on the other hand will always return `{error, blocked}` and essentially short circuits that way. This can be useful when you truly don't want to accept any requests any more for this particular rate limiter.\n\nYou can pass any other key-value pair when configuring a speed trap. They will be present when inspecting speed traps\n(by calling speed_trap:all()).\n\nA new speed trap always starts with a full bucket.\n\nThere is several different ways to achieve the same rate limit. For example, one wants to have\nthe base rate of 100 requests per second. All the following ways to define it are correct:\n1. Set the refill interval to 1 second, and the refill count to 100;\n2. Set the refill interval to 100 milliseconds, and the refill count to 10;\n3. Set the refill interval to 10 milliseconds, and the refill count to 1.\n\nIn all cases all available tokens can be consumed as soon as possible and then a client will get\n`{error, too_many_requests}` until the bucket is refilled again. The difference, however, is how\nnew tokens are distributed across the 1 second period. Assume that one creates speed traps with\nthe bucket size of 100.\n\nLet's say the trap with the refill options from the first way was created at 00.000s and a client\nconsumes one token per milliseconds. The bucket becomes empty at 00.100s and will be refilled to\n100 at 01.000s.\n\n|  Time   |  Available Tokens  |\n|---------|--------------------|\n| 00.000s | 100 (full bucket)  |\n| 00.001s | 99 (1 consumed)    |\n| 00.002s | 98 (1 consumed)    |\n| ...     | ...                |\n| 00.100s | 0  (1 consumed)    |\n| 01.000s | 100 (100 refilled) |\n\nIn the second and the third cases, the availability of tokens are distributed evenly accross the\ncorrespondent refill intervals. Let's take the 3rd configuration as an example.\n\n* The trap is created at 00.000s, 100 tokens are available to a client. The client consumes one\n  token per millisecond.\n* At 00.010s the number of available tokens is 91: 90 that haven't been consumed yet plus one\n  which is refilled.\n* At 00.020 the total number of tokens in the bucket is 82: 81 haven't been consumed plus\n  the refilled one.\n* And so on.\n\n|  Time   | Available Tokens  |\n|---------|-------------------|\n| 00.000s | 100 (full bucket) |\n| 00.001s | 99 (1 consumed)   |\n| 00.002s | 98 (1 consumed)   |\n| ...     | ...               |\n| 00.010s | 90 (1 consumed)   |\n| 00.010s | 91 (1 refilled)   |\n| 00.011s | 90 (1 consumed)   |\n| 00.011s | 89 (1 consumed)   |\n| ...     | ...               |\n| 00.020s | 81 (1 consumed)   |\n| 00.020s | 82 (1 refilled)   |\n| 00.021s | 81 (1 consumed)   |\n\nNotice, that the momentary peak rate can be as high as the bucket size. This might be especially\nimportant when the requests are distributed unevenly. So, if one wants to support short periods\nwith burst of requests on the system with a relatively low base rate, one could set the bucket\nsize parameter to a higher value.\n\nIt does not make sense to set the bucket size to a lower value than the refill count because\nin this case the bucket will contain the overflowing tokens anyway.","ref":"readme.html#how-to-parameterise-a-rate-limiter","title":"How to parameterise a rate limiter? - Overview","type":"extras"},{"doc":"Example of setting up and using a rate limiter for POST requests to the captcha page\nthat should handle a 10 requests per minute base load and allow 50 requests per minute\npeaks:\n\n```erlang\napplication:ensure_all_started(speed_trap).\nId = {<<\"/api/v1/captcha_challenge\">>, <<\"POST\">>}.\nOptions = #{bucket_size => 40,                   % difference of peak and base rates\n            refill_interval => timer:seconds(6), % how often the bucket is refilled\n            refill_count => 1,                   % number of tokens to refill\n            delete_when_full => false            % Do not delete bucket when full\n            override => none                     % No overrides\n           },\nspeed_trap:new(Id, Options).                     % ok | raises the bad_options error\nspeed_trap:try_pass(Id).                         % {ok, RemainingTokens | rate_limit_not_enforced} | {error, too_many_requests}\n```\n\nIn order to modify the rate limiters one can use modify/2:\n```erlang\nNewRefillInterval = timer:seconds(1),\nspeed_trap:modify(Id, #{refill_interval => NewRefillInterval}).\n```\n\nIn order to delete a rate limiter:\n```erlang\nspeed_trap:delete(Id).\n```","ref":"readme.html#usage-example","title":"Usage example - Overview","type":"extras"},{"doc":"When you do not know upfront all the rate limiters that you need you can add templates for rate limiters and connect them to rate limiter id patterns.\nWhen a speed trap is not present when calling speed_trap:try_pass/1, speed_trap looks for a pattern\nthat matches the supplied id.\nIf found a rate limiter with the id is created.\n\nThe template is a tuple of a template identifier and the same options map as used when calling speed_trap:new/2.\nAn id pattern is a tuple of a match head and a template identifier for the pattern.\n\nSay that you want a unique rate limiter (with the same configuration) for each user for a resource called my_resource.\nFor the user \"Alex\" the rate limiter id would be {my_resource, \"Alex\"}.\n\nA speed trap that is started from a template will have the template id stored with its options.\nThis can be used when dynamically reconfiguring speed traps or when debugging a running system.\n\n```erlang\n{templates,\n #{my_resource_template =>\n  #{bucket_size => 40,\n    refill_interval => 6000,\n    refill_count => 1,\n    delete_when_full => true,\n    override => none\n   }\n }\n},\n{id_patterns,\n [\n  {\n   {my_resource, '_'},\n    my_resource_template\n  }\n ]\n}\n```","ref":"readme.html#template-rate-limiters","title":"Template rate limiters - Overview","type":"extras"},{"doc":"In order to build the project simply run `make`.\n\nThis repo uses `rebar3 format` to ensure consistent formatting of the codebase.\nIf the pipeline fails with:\n```sh\n===> The following files are not properly formatted:\nsrc/ .erl\n```\nPlease run `make format` and commit the changes.","ref":"readme.html#development","title":"Development - Overview","type":"extras"},{"doc":"```bash\nmake test\n```","ref":"readme.html#running-tests","title":"Running tests - Overview","type":"extras"},{"doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright [yyyy] [name of copyright owner]\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html","title":"License","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,50,46,50]}}